/*
 * Copyright 2013-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You may not use this file except in compliance with
 * the License. A copy of the License is located at
 * 
 * http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions
 * and limitations under the License.
 */
package com.amazonaws.services.costexplorer.model;

import java.io.Serializable;
import javax.annotation.Generated;
import com.amazonaws.protocol.StructuredPojo;
import com.amazonaws.protocol.ProtocolMarshaller;

/**
 * <p>
 * The amount of instance usage that a reservation covered.
 * </p>
 * 
 * @see <a href="http://docs.aws.amazon.com/goto/WebAPI/ce-2017-10-25/Coverage" target="_top">AWS API Documentation</a>
 */
@Generated("com.amazonaws:aws-java-sdk-code-generator")
public class Coverage implements Serializable, Cloneable, StructuredPojo {

    /**
     * <p>
     * The amount of instance usage that a reservation covered, in hours.
     * </p>
     */
    private CoverageHours coverageHours;

    /**
     * <p>
     * The amount of instance usage that a reservation covered, in hours.
     * </p>
     * 
     * @param coverageHours
     *        The amount of instance usage that a reservation covered, in hours.
     */

    public void setCoverageHours(CoverageHours coverageHours) {
        this.coverageHours = coverageHours;
    }

    /**
     * <p>
     * The amount of instance usage that a reservation covered, in hours.
     * </p>
     * 
     * @return The amount of instance usage that a reservation covered, in hours.
     */

    public CoverageHours getCoverageHours() {
        return this.coverageHours;
    }

    /**
     * <p>
     * The amount of instance usage that a reservation covered, in hours.
     * </p>
     * 
     * @param coverageHours
     *        The amount of instance usage that a reservation covered, in hours.
     * @return Returns a reference to this object so that method calls can be chained together.
     */

    public Coverage withCoverageHours(CoverageHours coverageHours) {
        setCoverageHours(coverageHours);
        return this;
    }

    /**
     * Returns a string representation of this object; useful for testing and debugging.
     *
     * @return A string representation of this object.
     *
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("{");
        if (getCoverageHours() != null)
            sb.append("CoverageHours: ").append(getCoverageHours());
        sb.append("}");
        return sb.toString();
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;

        if (obj instanceof Coverage == false)
            return false;
        Coverage other = (Coverage) obj;
        if (other.getCoverageHours() == null ^ this.getCoverageHours() == null)
            return false;
        if (other.getCoverageHours() != null && other.getCoverageHours().equals(this.getCoverageHours()) == false)
            return false;
        return true;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int hashCode = 1;

        hashCode = prime * hashCode + ((getCoverageHours() == null) ? 0 : getCoverageHours().hashCode());
        return hashCode;
    }

    @Override
    public Coverage clone() {
        try {
            return (Coverage) super.clone();
        } catch (CloneNotSupportedException e) {
            throw new IllegalStateException("Got a CloneNotSupportedException from Object.clone() " + "even though we're Cloneable!", e);
        }
    }

    @com.amazonaws.annotation.SdkInternalApi
    @Override
    public void marshall(ProtocolMarshaller protocolMarshaller) {
        com.amazonaws.services.costexplorer.model.transform.CoverageMarshaller.getInstance().marshall(this, protocolMarshaller);
    }
}
